/*
* Copyright 2020 NXP
* SPDX-License-Identifier: BSD-3-Clause
*/

#ifndef INTC_H_
#define INTC_H_

/************************************ INTC interrupt priority related MACRO ******************************************/

#define INT_DISABLE 0
#define CPU_INTRUPT_LEVEL_1 1
#define CPU_INTRUPT_LEVEL_2 2
#define CPU_INTRUPT_LEVEL_3 3
#define PERIPH_INTRUPT_LEVEL_0 1
#define PERIPH_INTRUPT_LEVEL_1 2
#define PERIPH_INTRUPT_LEVEL_2 3

#define INTERRUPT_CONFIG(interrupt_source,level) INTERRUPT_CONFIG1(interrupt_source,level)
#define INTERRUPT_CONFIG1(interrupt_source,level) INTERRUPT_CONFIG2(interrupt_source##_ipr_no,interrupt_source##_MASK,_##interrupt_source,level)

// CPU interrupt sources
#define STEP_COUNTER_INTRUPT 	STEP_COUNTER_INTRUPT
#define BREAK_POINT_INTRUPT  	BREAK_POINT_INTRUPT
#define TRACE_BUFFER_INTRUPT 	TRACE_BUFFER_INTRUPT
#define TX_REGISTER_EMPTY_INTRUPT	TX_REGISTER_EMPTY_INTRUPT
#define RX_REGISTER_FULL_INTRUPT	RX_REGISTER_FULL_INTRUPT
#define BUS_ERROR_INTRUPT		BUS_ERROR_INTRUPT
// Peripheral interrupt sources
#define XBARA_INTRUPT 		XBARA_INTRUPT
#define LVI1_INTRUPT  		LVI1_INTRUPT
#define OCCS_INTRUPT		OCCS_INTRUPT
#define QTimer_A3_INTRUPT	QTimer_A3_INTRUPT
#define QTimer_A2_INTRUPT	QTimer_A2_INTRUPT
#define QTimer_A1_INTRUPT	QTimer_A1_INTRUPT
#define QTimer_A0_INTRUPT	QTimer_A0_INTRUPT
#define ADC0_INTRUPT		ADC0_INTRUPT
#define ADC1_INTRUPT		ADC1_INTRUPT
#define ADC_ERR_INTRUPT		ADC_ERR_INTRUPT
#define DMA_ERR_INTRUPT		DMA_ERR_INTRUPT
#define DMA_CH3_INTRUPT		DMA_CH3_INTRUPT
#define DMA_CH2_INTRUPT		DMA_CH2_INTRUPT
#define DMA_CH1_INTRUPT		DMA_CH1_INTRUPT
#define DMA_CH0_INTRUPT		DMA_CH0_INTRUPT
#define QSCI1_RERR_INTRUPT	QSCI1_RERR_INTRUPT
#define QSCI1_RCV_INTRUPT	QSCI1_RCV_INTRUPT
#define QSCI1_TRIDLE_INTRUPT	QSCI1_TRIDLE_INTRUPT
#define QSCI1_TDRE_INTRUPT	QSCI1_TDRE_INTRUPT
#define QSCI0_RERR_INTRUPT	QSCI0_RERR_INTRUPT
#define QSCI0_RCV_INTRUPT	QSCI0_RCV_INTRUPT
#define QSCI0_TRIDLE_INTRUPT	QSCI0_TRIDLE_INTRUPT
#define QSCI0_TDRE_INTRUPT	QSCI0_TDRE_INTRUPT
#define QSPI_XMIT_INTRUPT	QSPI_XMIT_INTRUPT
#define QSPI_RCV_INTRUPT	QSPI_RCV_INTRUPT
#define LPI2C1_INTRUPT		LPI2C1_INTRUPT
#define LPI2C0_INTRUPT		LPI2C0_INTRUPT
#define PWMA_FAULT_INTRUPT	PWMA_FAULT_INTRUPT
#define PWMA_RERR_INTRUPT	PWMA_RERR_INTRUPT
#define PWMA_CAP_INTRUPT	PWMA_CAP_INTRUPT
#define PWMA_RELOAD3_INTRUPT	PWMA_RELOAD3_INTRUPT
#define PWMA_CMP3_INTRUPT	PWMA_CMP3_INTRUPT
#define PWMA_RELOAD2_INTRUPT	PWMA_RELOAD2_INTRUPT
#define PWMA_CMP2_INTRUPT	PWMA_CMP2_INTRUPT
#define PWMA_RELOAD1_INTRUPT	PWMA_RELOAD1_INTRUPT
#define PWMA_CMP1_INTRUPT	PWMA_CMP1_INTRUPT
#define PWMA_RELOAD0_INTRUPT	PWMA_RELOAD0_INTRUPT
#define PWMA_CMP0_INTRUPT	PWMA_CMP0_INTRUPT
#define FTFA_RDCOL_INTRUPT	FTFA_RDCOL_INTRUPT
#define FTFA_CC_INTRUPT		FTFA_CC_INTRUPT
#define CMPD_INTRUPT		CMPD_INTRUPT
#define CMPC_INTRUPT		CMPC_INTRUPT
#define CMPB_OPAMPB_INTRUPT		CMPB_OPAMPB_INTRUPT
#define CMPA_OPAMPA_INTRUPT		CMPA_OPAMPA_INTRUPT
#define PIT1_ROLLOVR_INTRUPT	PIT1_ROLLOVR_INTRUPT
#define PIT0_ROLLOVR_INTRUPT	PIT0_ROLLOVR_INTRUPT
#define QDC_INDEX_ROLL_CMP      QDC_INDEX_ROLL_CMP
#define QDC_HOME_WDG_PHAB       QDC_HOME_WDG_PHAB
#define GPIOF_INTRUPT		GPIOF_INTRUPT
#define GPIOE_INTRUPT		GPIOE_INTRUPT
#define GPIOD_INTRUPT		GPIOD_INTRUPT
#define GPIOC_INTRUPT		GPIOC_INTRUPT
#define GPIOB_INTRUPT		GPIOB_INTRUPT
#define GPIOA_INTRUPT		GPIOA_INTRUPT
#define COP_INTRUPT			COP_INTRUPT
#define EWM_INTRUPT			EWM_INTRUPT
#define DSASS_INTRUPT		DSASS_INTRUPT


// Interrupt IPR register number
#define STEP_COUNTER_INTRUPT_ipr_no 	0
#define BREAK_POINT_INTRUPT_ipr_no  	0
#define TRACE_BUFFER_INTRUPT_ipr_no 	0
#define TX_REGISTER_EMPTY_INTRUPT_ipr_no	0
#define RX_REGISTER_FULL_INTRUPT_ipr_no	0
#define BUS_ERROR_INTRUPT_ipr_no		0
#define XBARA_INTRUPT_ipr_no 			1
#define LVI1_INTRUPT_ipr_no  			1
#define OCCS_INTRUPT_ipr_no			1
#define QTimer_A3_INTRUPT_ipr_no	2
#define QTimer_A2_INTRUPT_ipr_no	2
#define QTimer_A1_INTRUPT_ipr_no	2
#define QTimer_A0_INTRUPT_ipr_no	2
#define ADC0_INTRUPT_ipr_no		2
#define ADC1_INTRUPT_ipr_no		2
#define ADC_ERR_INTRUPT_ipr_no		2
#define DMA_ERR_INTRUPT_ipr_no		2
#define DMA_CH3_INTRUPT_ipr_no		3
#define DMA_CH2_INTRUPT_ipr_no		3
#define DMA_CH1_INTRUPT_ipr_no		3
#define DMA_CH0_INTRUPT_ipr_no		3
#define QSCI1_RERR_INTRUPT_ipr_no	4
#define QSCI1_RCV_INTRUPT_ipr_no	4
#define QSCI1_TRIDLE_INTRUPT_ipr_no	5
#define QSCI1_TDRE_INTRUPT_ipr_no	5
#define QSCI0_RERR_INTRUPT_ipr_no	5
#define QSCI0_RCV_INTRUPT_ipr_no	5
#define QSCI0_TRIDLE_INTRUPT_ipr_no	5
#define QSCI0_TDRE_INTRUPT_ipr_no	5
#define QSPI0_XMIT_INTRUPT_ipr_no	6
#define QSPI0_RCV_INTRUPT_ipr_no	6
#define LPI2C1_INTRUPT_ipr_no			6
#define LPI2C0_INTRUPT_ipr_no			6

#define PWMA_FAULT_INTRUPT_ipr_no	8
#define PWMA_RERR_INTRUPT_ipr_no	8
#define PWMA_CAP_INTRUPT_ipr_no		8
#define PWMA_RELOAD3_INTRUPT_ipr_no	8
#define PWMA_CMP3_INTRUPT_ipr_no	9
#define PWMA_RELOAD2_INTRUPT_ipr_no	9
#define PWMA_CMP2_INTRUPT_ipr_no	9
#define PWMA_RELOAD1_INTRUPT_ipr_no	9
#define PWMA_CMP1_INTRUPT_ipr_no	9
#define PWMA_RELOAD0_INTRUPT_ipr_no	9
#define PWMA_CMP0_INTRUPT_ipr_no	9
#define FTFA_RDCOL_INTRUPT_ipr_no	9
#define FTFA_CC_INTRUPT_ipr_no		10
#define CMPD_INTRUPT_ipr_no		10
#define CMPC_INTRUPT_ipr_no		10
#define CMPB_INTRUPT_ipr_no		10
#define CMPA_INTRUPT_ipr_no		10
#define PIT1_ROLLOVR_INTRUPT_ipr_no	10
#define PIT0_ROLLOVR_INTRUPT_ipr_no	10
#define GPIOF_INTRUPT_ipr_no		11
#define GPIOE_INTRUPT_ipr_no		11
#define GPIOD_INTRUPT_ipr_no		11
#define QDC_HOME_WDG_PHAB_INTRUPT_ipr_no		11
#define QDC_INDEX_ROLL_CMP_INTRUPT_ipr_no		11
#define GPIOC_INTRUPT_ipr_no		12
#define GPIOB_INTRUPT_ipr_no		12
#define GPIOA_INTRUPT_ipr_no		12
#define COP_INTRUPT_ipr_no			12
#define EWM_INTRUPT_ipr_no			12
#define DSASS_INTRUPT_ipr_no			12

// IPR Mask
#define STEP_COUNTER_INTRUPT_MASK 	STPCNT_MASK
#define BREAK_POINT_INTRUPT_MASK  	BKPT_MASK
#define TRACE_BUFFER_INTRUPT_MASK 	TRBUF_MASK
#define TX_REGISTER_EMPTY_INTRUPT_MASK	TX_REG_MASK
#define RX_REGISTER_FULL_INTRUPT_MASK	RX_REG_MASK
#define BUS_ERROR_INTRUPT_MASK		BUS_ERR_MASK
#define XBARA_INTRUPT_MASK 		XBARA_MASK
#define LVI1_INTRUPT_MASK  		LVI1_MASK
#define OCCS_INTRUPT_MASK		OCCS_MASK
#define QTimer_A3_INTRUPT_MASK	TMRA_3_MASK
#define QTimer_A2_INTRUPT_MASK	TMRA_2_MASK
#define QTimer_A1_INTRUPT_MASK	TMRA_1_MASK
#define QTimer_A0_INTRUPT_MASK	TMRA_0_MASK
#define ADC0_INTRUPT_MASK		ADC_CC0_MASK
#define ADC1_INTRUPT_MASK		ADC_CC1_MASK
#define ADC_ERR_INTRUPT_MASK		ADC_ERR_MASK
#define DMA_ERR_INTRUPT_MASK		DMA_ERR_MASK
#define DMA_CH3_INTRUPT_MASK		DMACH3_MASK
#define DMA_CH2_INTRUPT_MASK		DMACH2_MASK
#define DMA_CH1_INTRUPT_MASK		DMACH1_MASK
#define DMA_CH0_INTRUPT_MASK		DMACH0_MASK

#define QSCI1_RERR_INTRUPT_MASK		QSCI1_RERR_MASK
#define QSCI1_RCV_INTRUPT_MASK		QSCI1_RCV_MASK
#define QSCI1_TRIDLE_INTRUPT_MASK	QSCI1_TRIDLE_MASK
#define QSCI1_TDRE_INTRUPT_MASK		QSCI1_TDRE_MASK
#define QSCI0_RERR_INTRUPT_MASK		QSCI0_RERR_MASK
#define QSCI0_RCV_INTRUPT_MASK		QSCI0_RCV_MASK
#define QSCI0_TRIDLE_INTRUPT_MASK	QSCI0_TRIDLE_MASK
#define QSCI0_TDRE_INTRUPT_MASK	QSCI0_TDRE_MASK
#define QSPI0_XMIT_INTRUPT_MASK	QSPI0_XMIT_MASK
#define QSPI0_RCV_INTRUPT_MASK	QSPI0_RCV_MASK
#define LPI2C1_INTRUPT_MASK		LPI2C1_MASK
#define LPI2C0_INTRUPT_MASK		LPI2C0_MASK
#define PWMA_FAULT_INTRUPT_MASK	PWMA_FAULT_MASK
#define PWMA_RERR_INTRUPT_MASK	PWMA_RERR_MASK
#define PWMA_CAP_INTRUPT_MASK	PWMA_CAP_MASK
#define PWMA_RELOAD3_INTRUPT_MASK	PWMA_RELOAD3_MASK
#define PWMA_CMP3_INTRUPT_MASK	PWMA_CMP3_MASK
#define PWMA_RELOAD2_INTRUPT_MASK	PWMA_RELOAD2_MASK
#define PWMA_CMP2_INTRUPT_MASK	PWMA_CMP2_MASK
#define PWMA_RELOAD1_INTRUPT_MASK	PWMA_RELOAD1_MASK
#define PWMA_CMP1_INTRUPT_MASK	PWMA_CMP1_MASK
#define PWMA_RELOAD0_INTRUPT_MASK	PWMA_RELOAD0_MASK
#define PWMA_CMP0_INTRUPT_MASK	PWMA_CMP0_MASK
#define FTFA_RDCOL_INTRUPT_MASK	FTFA_RDCOL_MASK
#define FTFA_CC_INTRUPT_MASK	FTFA_CC_MASK
#define CMPD_INTRUPT_MASK		CMPD_MASK
#define CMPC_INTRUPT_MASK		CMPC_MASK
#define CMPB_INTRUPT_MASK		CMPB_MASK
#define CMPA_INTRUPT_MASK		CMPA_MASK
#define PIT1_ROLLOVR_INTRUPT_MASK	PIT1_ROLLOVR_MASK
#define PIT0_ROLLOVR_INTRUPT_MASK	PIT0_ROLLOVR_MASK

#define QDC_HOME_WDG_PHAB_INTRUPT_MASK		UNDEFINED_MASK
#define QDC_INDEX_ROLL_CMP_INTRUPT_MASK		UNDEFINED_MASK

#define GPIOF_INTRUPT_MASK		GPIOF_MASK
#define GPIOE_INTRUPT_MASK		GPIOE_MASK
#define GPIOD_INTRUPT_MASK		GPIOD_MASK
#define GPIOC_INTRUPT_MASK		GPIOC_MASK
#define GPIOB_INTRUPT_MASK		GPIOB_MASK
#define GPIOA_INTRUPT_MASK		GPIOA_MASK
#define COP_INTRUPT_MASK			COP_INT_MASK
#define EWM_INTRUPT_MASK			EWM_INT_MASK
#define DSASS_INTRUPT_MASK			DSASS_MASK

// IPR bit field suffix
#define _STEP_COUNTER_INTRUPT 		_STPCNT
#define _BREAK_POINT_INTRUPT  		_BKPT
#define _TRACE_BUFFER_INTRUPT 		_TRBUF
#define _TX_REGISTER_EMPTY_INTRUPT	_TX_REG
#define _RX_REGISTER_FULL_INTRUPT	_RX_REG
#define _BUS_ERROR_INTRUPT			_BUS_ERR
#define _XBARA_INTRUPT 		_XBARA
#define _LVI1_INTRUPT  		_LVI1
#define _OCCS_INTRUPT		_OCCS
#define _QTimer_A3_INTRUPT	_TMRA_3
#define _QTimer_A2_INTRUPT	_TMRA_2
#define _QTimer_A1_INTRUPT	_TMRA_1
#define _QTimer_A0_INTRUPT	_TMRA_0
#define _ADC0_INTRUPT		_ADC_CC0
#define _ADC1_INTRUPT		_ADC_CC1
#define _ADC_ERR_INTRUPT		_ADC_ERR
#define _DMA_ERR_INTRUPT		_DMA_ERR
#define _DMA_CH3_INTRUPT		_DMACH3
#define _DMA_CH2_INTRUPT		_DMACH2
#define _DMA_CH1_INTRUPT		_DMACH1
#define _DMA_CH0_INTRUPT		_DMACH0

#define _QSCI1_RERR_INTRUPT		_QSCI1_RERR
#define _QSCI1_RCV_INTRUPT		_QSCI1_RCV
#define _QSCI1_TRIDLE_INTRUPT	_QSCI1_TRIDLE
#define _QSCI1_TDRE_INTRUPT		_QSCI1_TDRE
#define _QSCI0_RERR_INTRUPT		_QSCI0_RERR
#define _QSCI0_RCV_INTRUPT		_QSCI0_RCV
#define _QSCI0_TRIDLE_INTRUPT	_QSCI0_TRIDLE
#define _QSCI0_TDRE_INTRUPT		_QSCI0_TDRE
#define _QSPI0_XMIT_INTRUPT		_QSPI0_XMIT
#define _QSPI0_RCV_INTRUPT		_QSPI0_RCV
#define _LPI2C1_INTRUPT			_LPI2C1
#define _LPI2C0_INTRUPT			_LPI2C0
#define _PWMA_FAULT_INTRUPT		_PWMA_FAULT
#define _PWMA_RERR_INTRUPT		_PWMA_RERR
#define _PWMA_CAP_INTRUPT		_PWMA_CAP
#define _PWMA_RELOAD3_INTRUPT	_PWMA_RELOAD3
#define _PWMA_CMP3_INTRUPT		_PWMA_CMP3
#define _PWMA_RELOAD2_INTRUPT	_PWMA_RELOAD2
#define _PWMA_CMP2_INTRUPT		_PWMA_CMP2
#define _PWMA_RELOAD1_INTRUPT	_PWMA_RELOAD1
#define _PWMA_CMP1_INTRUPT		_PWMA_CMP1
#define _PWMA_RELOAD0_INTRUPT	_PWMA_RELOAD0
#define _PWMA_CMP0_INTRUPT		_PWMA_CMP0
#define _FTFA_RDCOL_INTRUPT		_FTFA_RDCOL
#define _FTFA_CC_INTRUPT		_FTFA_CC
#define _CMPD_INTRUPT		_CMPD
#define _CMPC_INTRUPT		_CMPC
#define _CMPB_INTRUPT		_CMPB
#define _CMPA_INTRUPT		_CMPA
#define _PIT1_ROLLOVR_INTRUPT	_PIT1_ROLLOVR
#define _PIT0_ROLLOVR_INTRUPT	_PIT0_ROLLOVR

#define _QDC_HOME_WDG_PHAB_INTRUPT		_UNDEFINED
#define _QDC_INDEX_ROLL_CMP_INTRUPT		_UNDEFINED

#define _GPIOF_INTRUPT		_GPIOF
#define _GPIOE_INTRUPT		_GPIOE
#define _GPIOD_INTRUPT		_GPIOD
#define _GPIOC_INTRUPT		_GPIOC
#define _GPIOB_INTRUPT		_GPIOB
#define _GPIOA_INTRUPT		_GPIOA
#define _COP_INTRUPT		_COP_INT
#define _EWM_INTRUPT		_EWM_INT
#define _DSASS_INTRUPT		_DSASS

#define INTERRUPT_CONFIG2(ipr_no,mask_name,mask_option,level) INTERRUPT_CONFIG3(ipr_no,mask_name,mask_option,level) 
#define INTERRUPT_CONFIG3(ipr_no,mask_name,mask_option,level) INTC->IPR##ipr_no &= ~INTC_IPR##ipr_no##_##mask_name;INTC->IPR##ipr_no |= INTC_IPR##ipr_no##mask_option(level)

/************************************ Fast interrupt related MACRO ******************************************/
#define STEP_COUNTER_NUM 		6
#define BREAK_POINT_NUM   		7
#define TRACE_BUFFER_NUM  		8
#define TX_REGISTER_EMPTY_NUM 	9
#define RX_REGISTER_FULL_NUM 	10
#define BUS_ERROR_NUM 			11
#define XBARA_NUM 				18
#define LVI1_NUM  				19
#define OCCS_NUM				20
#define QTimer_A3_NUM			25
#define QTimer_A2_NUM			26
#define QTimer_A1_NUM			27
#define QTimer_A0_NUM			28
#define ADC1_NUM				29		
#define ADC0_NUM				30
#define ADC_ERR_NUM				31
#define DMA_ERR_NUM				32
#define DMA_CH3_NUM				33
#define DMA_CH2_NUM				34
#define DMA_CH1_NUM				35
#define DMA_CH0_NUM				36

#define QSCI1_RERR_NUM			47
#define QSCI1_RCV_NUM			48
#define QSCI1_TRIDLE_NUM		49
#define QSCI1_TDRE_NUM			50
#define QSCI0_RERR_NUM			51
#define QSCI0_RCV_NUM			52
#define QSCI0_TRIDLE_NUM		53
#define QSCI0_TDRE_NUM			54

#define QSPI0_XMIT_NUM			59
#define QSPI0_RCV_NUM			60
#define LPI2C1_NUM				61
#define LPI2C0_NUM				62

#define PWMA_FAULT_NUM			77
#define PWMA_RERR_NUM			78
#define PWMA_CAP_NUM			79
#define PWMA_RELOAD3_NUM		80
#define PWMA_CMP3_NUM			81
#define PWMA_RELOAD2_NUM		82
#define PWMA_CMP2_NUM			83
#define PWMA_RELOAD1_NUM		84
#define PWMA_CMP1_NUM			85
#define PWMA_RELOAD0_NUM		86
#define PWMA_CMP0_NUM			87
#define FTFA_RDCOL_NUM			88
#define FTFA_CC_NUM				89
#define CMPD_NUM				90
#define CMPC_NUM				91
#define CMPB_NUM				92
#define CMPA_NUM				93
#define PIT1_ROLLOVR_NUM		94
#define PIT0_ROLLOVR_NUM		95

#define QDC_INDEX_ROLL_CMP_NUM		99
#define QDC_HOME_WDG_PHAB_NUM		100

#define GPIOF_NUM				102
#define GPIOE_NUM				103
#define GPIOD_NUM				104
#define GPIOC_NUM				105
#define GPIOB_NUM				106
#define GPIOA_NUM				107
#define COP_NUM					108
#define EWM_NUM					109
#define DSASS_NUM					112

#define CONFIG_FAST_INTERRUPT_0(vector_num) INTC->FIM0 &= ~INTC_FIM0_FAST_INTERRUPT_0_MASK;INTC->FIM0 |= INTC_FIM0_FAST_INTERRUPT_0(vector_num)
#define CONFIG_FAST_INTERRUPT_1(vector_num) INTC->FIM1 &= ~INTC_FIM0_FAST_INTERRUPT_1_MASK;INTC->FIM1 |= INTC_FIM1_FAST_INTERRUPT_0(vector_num)
#define SET_ADDR_TO_FAST_INTERRUPT_0(addr) INTC->FIVAL0=((uint32_t)(addr))&0xffff;INTC->FIVAH0=((uint32_t)(addr)>>16)&0xffff;
#define SET_ADDR_TO_FAST_INTERRUPT_1(addr) INTC->FIVAL1=((uint32_t)(addr))&0xffff;INTC->FIVAH1=((uint32_t)(addr)>>16)&0xffff;

// Disable interrupt at INTC. This is a master switch in INTC. 
#define INTC_INT_DISABLE() INTC->CTRL |= INTC_CTRL_INT_DIS_MASK

// Enable interrupt at INTC. Interrupt is enabled by default after reset
#define INTC_INT_ENABLE() INTC->CTRL &= ~INTC_CTRL_INT_DIS_MASK

#endif /* INTC_H_ */
