/*
* Copyright 2020 NXP
* SPDX-License-Identifier: BSD-3-Clause
*/

#ifndef PERIPHEARLS_H_
#define PERIPHEARLS_H_

#include "derivative.h"
#include "sim.h"
#include "intc.h"
#include "xbar.h"
/******************************************
 * Definitions
 ******************************************/
#define MASK_BIT15 0x8000
#define MASK_BIT14 0x4000
#define MASK_BIT13 0x2000
#define MASK_BIT12 0x1000
#define MASK_BIT11 0x0800
#define MASK_BIT10 0x0400
#define MASK_BIT9 0x0200
#define MASK_BIT8 0x0100
#define MASK_BIT7 0x0080
#define MASK_BIT6 0x0040
#define MASK_BIT5 0x0020
#define MASK_BIT4 0x0010
#define MASK_BIT3 0x0008
#define MASK_BIT2 0x0004
#define MASK_BIT1 0x0002
#define MASK_BIT0 0x0001

#define LED_RED_OFF() (GPIOF->DR |= MASK_BIT6)
#define LED_RED_ON() (GPIOF->DR &= ~MASK_BIT6)
#define LED_GREEN_OFF() (GPIOF->DR |= MASK_BIT7)
#define LED_GREEN_ON() (GPIOF->DR &= ~MASK_BIT7)
#define LED_BLUE_OFF() (GPIOF->DR |= MASK_BIT4)
#define LED_BLUE_ON() (GPIOF->DR &= ~MASK_BIT4)
#define LED_YELLOW_OFF() (GPIOF->DR |= MASK_BIT5)
#define LED_YELLOW_ON() (GPIOF->DR &= ~MASK_BIT5)
#define LED_RED_TOGGLE() (GPIOF->DR ^= MASK_BIT6)
#define LED_GREEN_TOGGLE() (GPIOF->DR ^= MASK_BIT7)
#define LED_BLUE_TOGGLE() (GPIOF->DR ^= MASK_BIT4)
#define LED_YELLOW_TOGGLE() (GPIOF->DR ^= MASK_BIT5)

/******************************************
 * API
 ******************************************/
extern void peripherals_init(void);
void pin_init(void);
void xbar_init(void);
void PWMA_3_init(void);
void TA0_init(void);
void eDMA_init(void);
void DMAMUX_init(void);
void SCI1_init(void);

#endif /* PERIPHEARLS_H_ */
