/*
* Copyright 2020 NXP
* SPDX-License-Identifier: BSD-3-Clause
*/

#include "derivative.h"
#include "Cpu.h"
#include "ISR.h"
#include "peripherals.h"
#include "freemaster.h"


/******************************************
 * variables
 ******************************************/
uint16_t uw16Cnt1 = 0;
uint16_t uw16Ton = 100;

/*!
 * @brief End of scan interrupt read sampling result and update PWM duty.
 */
#pragma interrupt on
void PWMA3_CMP_Isr() //20kHz
{
	PWM->SM[3].STS |= PWM_STS_CMPF(1); // clear flag
	
	/* led indicates the code is runing */
	if(++uw16Cnt1 > 10000)
	{
		uw16Cnt1 = 0;
		LED_RED_TOGGLE();
	}
	
	uw16Ton += 20;
	if(uw16Ton > 3999) uw16Ton = 100;
	PWM->SM[3].VAL3 = uw16Ton;
	PWM->MCTRL |= PWM_MCTRL_LDOK(0x8);
	
	FMSTR_Recorder();
}
#pragma interrupt off


