/*
* Copyright 2020 NXP
* SPDX-License-Identifier: BSD-3-Clause
*/

#include <stdio.h>
#include <stdlib.h>
#include "Cpu.h"
#include "derivative.h" /* include peripheral declarations */
#include "peripherals.h"
#include "freemaster.h"

extern uint16_t vba_vector_addr;


void main(void)
{
  INTC->VBA = (uint16_t)(&vba_vector_addr);
  __EI(0); // enable interrupts of all priorities

  peripherals_init();
  FMSTR_Init();
 
  PWM->MCTRL |= PWM_MCTRL_RUN(0x8); // SM3 begins to run	
    
  while(1) {
  	FMSTR_Poll();
  }
}


